#######################################################################
#!/usr/bin/perl
# Easy deployment code for Metrocluster XPCA
# (C)  Copyright 2008-2011 Hewlett-Packard Development Company, L.P.
# @(#)  Metrocluster Easy Deployment script.
# @(#)  Product Name                :  HP Metrocluster
# @(#)  Product Version             :  A.10.00
# @(#)  Patch Name                  :  PHSS_41656 (HP-UX 11iv3) / PHSS_41655 (HP-UX 11iv2)
#
# *** Note: This file MUST NOT be edited. *****
#
# Any changes made to it will be overwritten when you upgrade to the
# next release of HP Serviceguard.
#
# Changing this file may lead to unrecoverable package startup
# and/or shutdown problems.
#
###################################################################

package utils;
require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(uniq_array trim split_merge_file find_line_no my_log my_log_array);

########################## Utility routine to remove duplicate elements from an array ###################
sub uniq_array {
    my @array = @_;
    my %seen  = ();
    foreach my $elem (@array) {
        $elem = trim($elem);
        next if $seen{$elem}++;
        push @unique, $elem;
    }
    return @unique;
}


#########################################################################################################

#######################################################################################
#
# Function Name: trim
# Input parameter: the string the needs to be trimmed
# Return value: the trimmed string
# Description: This function removes the leading and trailing whitespaces from the
#               string. whitespace implies [:space:] as defined by POSIX
#######################################################################################

sub trim {
    my $string = shift;
    $string =~ s/^\s+|\s+$//g;
    return $string;
}

##################### Utility routine to split and merge files ###############################

sub split_merge_file {
    $line_no       = $_[0];
    $head_line     = $line_no - 1;
    $tail_line     = $line_no + 1;
    $file_name     = $_[1];
    $new_file_name = $_[2];
    `rm -rf $new_file_name`;
    `head -$head_line $file_name >> $new_file_name`;
    `tail +$tail_line $file_name >> $new_file_name`;
    `mv -f $new_file_name $file_name 2>/dev/null`;
}

#################### Utility routine to find the line no of given string ######################
sub find_line_no {
    $file_name   = $_[0];
    $find_string = $_[1];
    @line_no     = `grep -n $find_string $file_name| awk -F: '{print \$1}'`;
    chomp( $line_no[0] );
    return $line_no[0];
}

###############################################################################################
sub my_log_array {
my (@log_arr) = @{$_[0]};
my $exit1 = $_[1];

foreach my $log_str (@log_arr){
chomp ($log_str);
$log_str =~ s/\.//g;
my_log($log_str,$exit1);
}

}

sub my_log{
my $log_msg = $_[0];
my $exit = $_[1];
$offset = 0;

while ( (length($log_msg)- $offset ) > 80 ) {

$print_msg = substr ( $log_msg,$offset,80 );
print $print_msg, "\n";
$offset=$offset+80;
}

$print_msg = substr ( $log_msg,$offset );
my $length = length( $print_msg );

if( ($length > 70 ) && ( $length <=80 ) ) {
print $print_msg;
while ( $length <= 80 ) {
print ".";
$length++;
}
print "\n";
$length = 0;
}
else {
print $print_msg;
}

while ( $length <= 70 ) {
print ".";
$length++;
}



if( $exit == 0 ) {
print ".[SUCCESS]";
}
elsif( $exit == 1) {
print "..[FAILED]";

}
elsif ( $exit == 2 ) {
print "[WARNING]";
}
else {
print "..........";
}


print "\n";

}
##########################################################################################################

1;
